import 'package:meta/meta.dart';

import 'binary_reader.dart';
import 'binary_writer.dart';

export 'binary_reader.dart';
export 'binary_writer.dart';

typedef Writer<T> = void Function(BinaryWriter writer, T obj);
typedef Reader<T> = T Function(BinaryReader reader);

/// Type adapters can be implemented to support non primitive values.
@immutable
class TypeAdapter<T> {
  const TypeAdapter({
    @required this.typeId,
    @required this.write,
    @required this.read,
  })  : assert(typeId != null),
        assert(write != null),
        assert(read != null);

  final int typeId;
  final Writer<T> write;
  final Reader<T> read;
}
