import 'package:portals/src/binary/type_adapter.dart';

/// TypeRegistries contain the [TypeAdapter]s associated with a typeId.
///
/// TypeIds have to be unique and must not change.
abstract class TypeRegistry {
  /// Register a [TypeAdapter] to announce it.
  void registerAdapter<T>(TypeAdapter<T> adapter);

  TypeAdapter<T> findAdapterByType<T>();

  TypeAdapter findAdapterById(int typeId);
}
